;Boot256b by TomCat/Abaddon
;Boot with your favorite 256b intro!

ORG 256
 MOV    AX,13H          ; graphic video mode for colored text
 INT    10H

 CALL   hello
 DB     3+8,'Boot256b by TomCat/Abaddon',13,10
 DB     'Boot with your favorite 256b intro!',13,10,0
hello:
 POP    SI              ; popsi is my favorite x86 instruction
 CALL   println

 CALL   get
 DB     7,'Get filename...',0
get:
 POP    SI
 CALL   print

 MOV    SI,80H
 MOVZX  CX,BYTE [SI]
 JCXZ   zero
 INC    SI
seek:
 CMP    BYTE [SI],' '
 JA     found
 INC    SI
 LOOP   seek
zero:
 JMP    error
found:
 MOV    DI,SI
seek2:
 CMP    BYTE [SI],' '
 JNA    found2
 INC    SI
 LOOP   seek2
found2:
 MOV    BYTE [SI],0
 CALL   printok

 CALL   open
 DB     7,'Load intro...',0
open:
 POP    SI
 CALL   print

 MOV    DX,DI
 MOV    AX,3D00H
 INT    21H
 JC     error
 XCHG   AX,BX
 MOV    DX,intro
 MOV    CX,512
 MOV    AH,3FH
 INT    21H
 XCHG   AX,BP
 MOV    AH,3EH
 INT    21H
 CALL   printok

 CALL   length
 DB     7,'Check file length...',0
length:
 POP    SI
 CALL   print
 CMP    BP,256
 JA     error
 CALL   printok

 CALL   read
 DB     7,'Read sector...',0
read:
 POP    SI
 CALL   print
 MOV    CX,3
retry:
 PUSH   CX
 MOV    BX,sector
 MOV    DX,0080H
 MOV    CX,0001H
 MOV    AX,0201H
 INT    13H
 POP    CX
 JNC    readok
 MOV    AH,0
 INT    13H
 LOOP   retry
 JMP    error
readok:
 CALL   printok

 CALL   mbr
 DB     7,'Check MBR...',0
mbr:
 POP    SI
 CALL   print
 CMP    WORD [sector+510],0AA55H
 JC     error
 CALL   printok

 CALL   find
 DB     7,'Find active partition...',0
find:
 POP    SI
 CALL   print
 MOV    DI,sector+510-4*16
 MOV    CX,4
next:
 CMP    [DI],CH
 JL     findok
 JNZ    error
 ADD    DI,16
 LOOP   next
 JMP    error
findok:
 CALL   printok

 CALL   boot
 DB     7,'Check boot...',0
boot:
 POP    SI
 CALL   print
 MOV    CX,3
retry2:
 PUSH   CX
 MOV    BX,sector2
 MOV    DX,[DI]
 MOV    CX,[DI+2]
 MOV    AX,0201H
 INT    13H
 POP    CX
 JNC    readok2
 MOV    AH,0
 INT    13H
 LOOP   retry2
 JMP    error
readok2:
 CMP    WORD [sector2+510],0AA55H
 JC     error
 CALL   printok

 CALL   patch
 DB     7,'Patch intro...',0
patch:
 POP    SI
 CALL   print
 MOV    SI,intro
 MOV    DI,newmbr+3BH
 MOV    CX,BP
 CLD
 REP    MOVSB
 MOV    SI,sector+510-4*16
 MOV    DI,newmbr+510-4*16
 MOV    CL,4*16+2
 REP    MOVSB
 CALL   printok

 CALL   write
 DB     7,'Write sector...',0
write:
 POP    SI
 CALL   print
 MOV    CX,3
retry3:
 PUSH   CX
 MOV    BX,newmbr
 MOV    DX,0080H
 MOV    CX,0001H
 MOV    AX,0301H
 INT    13H
 POP    CX
 JNC    writeok
 MOV    AH,0
 INT    13H
 LOOP   retry3
 JMP    error
writeok:
 CALL   printok

 CALL   bye
 DB     6,13,10,'Done. Have a nice reboot!',0
bye:
 POP    SI
 CALL   print
 JMP    done
error:
 CALL   failed
 DB     4+8,' Failed',0
failed:
 POP    SI
 CALL   println
done:
 MOV    AH,0
 INT    16H
 MOV    AX,3
 INT    10H
return:
RETN

printok:
 CALL   ok
 DB     2+8,' Ok',0
ok:
 POP    SI
println:
 CALL   print
 CALL   newline
 DB     0,13,10,0
newline:
 POP    SI
print:
 LODSB
 MOV    BL,AL
char:
 LODSB
 TEST   AL,AL
 JZ     return
 MOV    AH,0EH
 INT    10H
 JMP    char

newmbr:
 file 'new_mbr.bin'
sector:
 rept 512 { DB ? }
sector2:
 rept 512 { DB ? }
intro:
